当前位置 主页 > 服务器问题 > win服务器问题汇总 > 最大化 缩小

    php 远程包含文件漏洞分析第1/6页

    栏目:win服务器问题汇总 时间:2019-10-31 10:13

    几乎所有的cgi程序都有这样的 bug,只是具体的表现方式不一样罢了。

    一、涉及到的危险函数〔include(),require()和include_once(),require_once()〕

    include() && require()语句:包括并运行指定文件。

    这两种结构除了在如何处理失败之外完全一样。include() 产生一个警告而 require() 则导致一个致命错误。换句话说,如果你想在遇到丢失文件时停止处理页面就用 require()。include() 就不是这样,脚本会继续运行。
    如果"allow_url_fopen"在 PHP 中被激活(默认配置),也可以用 URL(通过 HTTP 或者其它支持的封装协议)而不是本地文件来指定要被包括的文件。如果目标服务器将目标文件作为 PHP 代码解释,则可以用适用于 HTTP GET 的 URL 请求字符串来向被包括的文件传递变量。
    详细参考:http://cn.php.net/manual/en/function.include.php

    require_once() && include_once()
    require_once ()和include_once() 语句在脚本执行期间包括并运行指定文件。此行为和 require() 语句类似,唯一区别是如果该文件中的代码已经被包括了,则不会再次包括。适用于在脚本执行期间同一个文件有可能被包括超过一次的情况下,你想确保它只被包括一次以避免函数重定义,变量重新赋值等问题。
    详细参考:http://cn.php.net/manual/en/function.require-once.php

    二、为什么要包含文件

    程序员写程序的时候,不喜欢干同样的事情,也不喜欢把同样的代码(比如一些公用的函数)写几次,于是就把需要公用的代码写在一个单独的文件里面,比如 share.php,而后在其它文件进行包含调用。在php里,我们就是使用上面列举的那几个函数来达到这个目的的,它的工作流程:如果你想在 main.php里包含share.php,我将这样写include("share.php")就达到目的,然后就可以使用share.php中的函数了,像这个写死需要包含的文件名称的自然没有什么问题,也不会出现漏洞,那么问题到底是出在哪里呢?
    有的时候可能不能确定需要包含哪个文件,比如先来看下面这个文件index.php的代码:
    [code]

    if ($_GET 123456下一页阅读全文